# CustomHbondForce Class Reference

This class supports a wide variety of energy functions used to represent hydrogen bonding. More...

`#include <CustomHbondForce.h>`

Inheritance diagram for CustomHbondForce:

List of all members.

## Classes

class | ExclusionInfo
| This is an internal class used to record information about an exclusion.
class | FunctionInfo
| This is an internal class used to record information about a tabulated function.
class | GlobalParameterInfo
| This is an internal class used to record information about a global parameter.
class | GroupInfo
| This is an internal class used to record information about a donor or acceptor.
class | PerPairParameterInfo
| This is an internal class used to record information about a per-donor or per-acceptor parameter.

## Public Types

enum | NonbondedMethod { NoCutoff = 0, CutoffNonPeriodic = 1, CutoffPeriodic = 2 }
| This is an enumeration of the different methods that may be used for handling long range nonbonded forces. More...

## Public Member Functions

| CustomHbondForce (const std::string &energy)
| Create a CustomHbondForce.
| ~CustomHbondForce ()
int | getNumDonors () const
| Get the number of donors for which force field parameters have been defined.
int | getNumAcceptors () const
| Get the number of acceptors for which force field parameters have been defined.
int | getNumExclusions () const
| Get the number of donor-acceptor pairs whose interactions should be excluded.
int | getNumPerDonorParameters () const
| Get the number of per-donor parameters that the interaction depends on.
int | getNumPerAcceptorParameters () const
| Get the number of per-acceptor parameters that the interaction depends on.
int | getNumGlobalParameters () const
| Get the number of global parameters that the interaction depends on.
int | getNumTabulatedFunctions () const
| Get the number of tabulated functions that have been defined.
int | getNumFunctions () const
| Get the number of tabulated functions that have been defined.
const std::string & | getEnergyFunction () const
| Get the algebraic expression that gives the interaction energy between a donor and an acceptor.
void | setEnergyFunction (const std::string &energy)
| Set the algebraic expression that gives the interaction energy between a donor and an acceptor.
NonbondedMethod | getNonbondedMethod () const
| Get the method used for handling long range nonbonded interactions.
void | setNonbondedMethod (NonbondedMethod method)
| Set the method used for handling long range nonbonded interactions.
double | getCutoffDistance () const
| Get the cutoff distance (in nm) being used.
void | setCutoffDistance (double distance)
| Set the cutoff distance (in nm) being used.
int | addPerDonorParameter (const std::string &name)
| Add a new per-donor parameter that the interaction may depend on.
const std::string & | getPerDonorParameterName (int index) const
| Get the name of a per-donor parameter.
void | setPerDonorParameterName (int index, const std::string &name)
| Set the name of a per-donor parameter.
int | addPerAcceptorParameter (const std::string &name)
| Add a new per-acceptor parameter that the interaction may depend on.
const std::string & | getPerAcceptorParameterName (int index) const
| Get the name of a per-acceptor parameter.
void | setPerAcceptorParameterName (int index, const std::string &name)
| Set the name of a per-acceptor parameter.
int | addGlobalParameter (const std::string &name, double defaultValue)
| Add a new global parameter that the interaction may depend on.
const std::string & | getGlobalParameterName (int index) const
| Get the name of a global parameter.
void | setGlobalParameterName (int index, const std::string &name)
| Set the name of a global parameter.
double | getGlobalParameterDefaultValue (int index) const
| Get the default value of a global parameter.
void | setGlobalParameterDefaultValue (int index, double defaultValue)
| Set the default value of a global parameter.
int | addDonor (int d1, int d2, int d3, const std::vector< double > &parameters)
| Add a donor group to the force.
void | getDonorParameters (int index, int &d1, int &d2, int &d3, std::vector< double > &parameters) const
| Get the properties of a donor group.
void | setDonorParameters (int index, int d1, int d2, int d3, const std::vector< double > &parameters)
| Set the properties of a donor group.
int | addAcceptor (int a1, int a2, int a3, const std::vector< double > &parameters)
| Add an acceptor group to the force.
void | getAcceptorParameters (int index, int &a1, int &a2, int &a3, std::vector< double > &parameters) const
| Get the properties of an acceptor group.
void | setAcceptorParameters (int index, int a1, int a2, int a3, const std::vector< double > &parameters)
| Set the properties of an acceptor group.
int | addExclusion (int donor, int acceptor)
| Add a donor-acceptor pair to the list of interactions that should be excluded.
void | getExclusionParticles (int index, int &donor, int &acceptor) const
| Get the donor and acceptor in a pair whose interaction should be excluded.
void | setExclusionParticles (int index, int donor, int acceptor)
| Get the donor and acceptor in a pair whose interaction should be excluded.
int | addTabulatedFunction (const std::string &name, TabulatedFunction *function)
| Add a tabulated function that may appear in the energy expression.
const TabulatedFunction & | getTabulatedFunction (int index) const
| Get a const reference to a tabulated function that may appear in the energy expression.
TabulatedFunction & | getTabulatedFunction (int index)
| Get a reference to a tabulated function that may appear in the energy expression.
const std::string & | getTabulatedFunctionName (int index) const
| Get the name of a tabulated function that may appear in the energy expression.
int | addFunction (const std::string &name, const std::vector< double > &values, double min, double max)
| Add a tabulated function that may appear in the energy expression.
void | getFunctionParameters (int index, std::string &name, std::vector< double > &values, double &min, double &max) const
| Get the parameters for a tabulated function that may appear in the energy expression.
void | setFunctionParameters (int index, const std::string &name, const std::vector< double > &values, double min, double max)
| Set the parameters for a tabulated function that may appear in the energy expression.
void | updateParametersInContext (Context &context)
| Update the per-donor and per-acceptor parameters in a Context to match those stored in this Force object.

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Detailed Description

This class supports a wide variety of energy functions used to represent hydrogen bonding.

It computes interactions between "donor" particle groups and "acceptor" particle groups, where each group may include up to three particles. Typically a donor group consists of a hydrogen atom and the atoms it is bonded to, and an acceptor group consists of a negatively charged atom and the atoms it is bonded to.

We refer to the particles in a donor group as d1, d2 and d3, and the particles in an acceptor group as a1, a2, and a3. For each donor and each acceptor, CustomHbondForce evaluates a user supplied algebraic expression to determine the interaction energy. The expression may depend on arbitrary distances, angles, and dihedral angles defined by any of the six particles involved. The function distance(p1, p2) is the distance between the particles p1 and p2 (where "p1" and "p2" should be replaced by the names of the actual particles to calculate the distance between), angle(p1, p2, p3) is the angle formed by the three specified particles, and dihedral(p1, p2, p3, p4) is the dihedral angle formed by the four specified particles.

The expression also may involve tabulated functions, and may depend on arbitrary global, per-donor, and per-acceptor parameters. It also optionally supports periodic boundary conditions and cutoffs for long range interactions.

To use this class, create a CustomHbondForce object, passing an algebraic expression to the constructor that defines the interaction energy between each donor and acceptor. Then call addPerDonorParameter() to define per-donor parameters, addPerAcceptorParameter() to define per-acceptor parameters, and addGlobalParameter() to define global parameters. The values of per-donor and per-acceptor parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context::setParameter().

Next, call addDonor() and addAcceptor() to define donors and acceptors and specify their parameter values. After a donor or acceptor has been added, you can modify its parameters by calling setDonorParameters() or setAcceptorParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

CustomHbondForce also lets you specify "exclusions", particular combinations of donors and acceptors whose interactions should be omitted from force and energy calculations. This is most often used for particles that are bonded to each other.

As an example, the following code creates a CustomHbondForce that implements a simple harmonic potential to keep the distance between a1 and d1, and the angle formed by a1-d1-d2, near ideal values:

`CustomHbondForce* force = new CustomHbondForce("k*(distance(a1,d1)-r0)^2*(angle(a1,d1,d2)-theta0)^2");`

This force depends on three parameters: k, r0, and theta0. The following code defines these as per-donor parameters:

``

     force->addPerDonorParameter("k");
     force->addPerDonorParameter("r0");
     force->addPerDonorParameter("theta0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, step, delta. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise.

In addition, you can call addTabulatedFunction() to define a new function based on tabulated values. You specify the function by creating a TabulatedFunction object. That function can then appear in the expression.

## Member Enumeration Documentation

enum NonbondedMethod

This is an enumeration of the different methods that may be used for handling long range nonbonded forces.

Enumerator:

  NoCutoff | No cutoff is applied to nonbonded interactions. The full set of N^2 interactions is computed exactly. This necessarily means that periodic boundary conditions cannot be used. This is the default.
  CutoffNonPeriodic | Interactions beyond the cutoff distance are ignored.
  CutoffPeriodic | Periodic boundary conditions are used, so that each particle interacts only with the nearest periodic copy of each other particle. Interactions beyond the cutoff distance are ignored.

## Constructor & Destructor Documentation

CustomHbondForce | ( | const std::string & | energy | ) | `[explicit]`

Create a CustomHbondForce.

Parameters:

  | energy | an algebraic expression giving the interaction energy between a donor and an acceptor as a function of inter-particle distances, angles, and dihedrals, as well as any global, per-donor, and per-acceptor parameters

~CustomHbondForce | ( |  | ) |

## Member Function Documentation

int addAcceptor | ( | int | a1,
|  | int | a2,
|  | int | a3,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Add an acceptor group to the force.

Parameters:

  | a1 | the index of the first particle for this acceptor group
  | a2 | the index of the second particle for this acceptor group. If the group only includes one particle, this must be -1.
  | a3 | the index of the third particle for this acceptor group. If the group includes less than three particles, this must be -1.
  | parameters | the list of per-acceptor parameter values for the new acceptor

Returns:
  the index of the acceptor that was added

int addDonor | ( | int | d1,
|  | int | d2,
|  | int | d3,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Add a donor group to the force.

Parameters:

  | d1 | the index of the first particle for this donor group
  | d2 | the index of the second particle for this donor group. If the group only includes one particle, this must be -1.
  | d3 | the index of the third particle for this donor group. If the group includes less than three particles, this must be -1.
  | parameters | the list of per-donor parameter values for the new donor

Returns:
  the index of the donor that was added

int addExclusion | ( | int | donor,
|  | int | acceptor |
| ) |  |  |

Add a donor-acceptor pair to the list of interactions that should be excluded.

Parameters:

  | donor | the index of the donor to exclude
  | acceptor | the index of the acceptor to exclude

Returns:
  the index of the exclusion that was added

int addFunction | ( | const std::string & | name,
|  | const std::vector< double > & | values,
|  | double | min,
|  | double | max |
| ) |  |  |

Add a tabulated function that may appear in the energy expression.

Deprecated:
  This method exists only for backward compatibility. Use addTabulatedFunction() instead.

int addGlobalParameter | ( | const std::string & | name,
|  | double | defaultValue |
| ) |  |  |

Add a new global parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter
  | defaultValue | the default value of the parameter

Returns:
  the index of the parameter that was added

int addPerAcceptorParameter | ( | const std::string & | name | ) |

Add a new per-acceptor parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter

Returns:
  the index of the parameter that was added

int addPerDonorParameter | ( | const std::string & | name | ) |

Add a new per-donor parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter

Returns:
  the index of the parameter that was added

int addTabulatedFunction | ( | const std::string & | name,
|  | TabulatedFunction * | function |
| ) |  |  |

Add a tabulated function that may appear in the energy expression.

Parameters:

  | name | the name of the function as it appears in expressions
  | function | a TabulatedFunction object defining the function. The TabulatedFunction should have been created on the heap with the "new" operator. The Force takes over ownership of it, and deletes it when the Force itself is deleted.

Returns:
  the index of the function that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

void getAcceptorParameters | ( | int | index,
|  | int & | a1,
|  | int & | a2,
|  | int & | a3,
|  | std::vector< double > & | parameters |
| ) |  |  | const

Get the properties of an acceptor group.

Parameters:

  | index | the index of the acceptor group to get
  | a1 | the index of the first particle for this acceptor group
  | a2 | the index of the second particle for this acceptor group. If the group only includes one particle, this will be -1.
  | a3 | the index of the third particle for this acceptor group. If the group includes less than three particles, this will be -1.
  | parameters | the list of per-acceptor parameter values for the acceptor

double getCutoffDistance | ( |  | ) | const

Get the cutoff distance (in nm) being used.

All interactions for which the distance between d1 and a1 is greater than the cutoff will be ignored. If the NonbondedMethod in use is NoCutoff, this value will have no effect.

Returns:
  the cutoff distance, measured in nm

void getDonorParameters | ( | int | index,
|  | int & | d1,
|  | int & | d2,
|  | int & | d3,
|  | std::vector< double > & | parameters |
| ) |  |  | const

Get the properties of a donor group.

Parameters:

  | index | the index of the donor group to get
  | d1 | the index of the first particle for this donor group
  | d2 | the index of the second particle for this donor group. If the group only includes one particle, this will be -1.
  | d3 | the index of the third particle for this donor group. If the group includes less than three particles, this will be -1.
  | parameters | the list of per-donor parameter values for the donor

const std::string& getEnergyFunction | ( |  | ) | const

Get the algebraic expression that gives the interaction energy between a donor and an acceptor.

void getExclusionParticles | ( | int | index,
|  | int & | donor,
|  | int & | acceptor |
| ) |  |  | const

Get the donor and acceptor in a pair whose interaction should be excluded.

Parameters:

  | index | the index of the exclusion for which to get donor and acceptor indices
  | particle1 | the index of the donor
  | particle2 | the index of the acceptor

void getFunctionParameters | ( | int | index,
|  | std::string & | name,
|  | std::vector< double > & | values,
|  | double & | min,
|  | double & | max |
| ) |  |  | const

Get the parameters for a tabulated function that may appear in the energy expression.

Deprecated:
  This method exists only for backward compatibility. Use getTabulatedFunctionParameters() instead. If the specified function is not a Continuous1DFunction, this throws an exception.

double getGlobalParameterDefaultValue | ( | int | index | ) | const

Get the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the default value

Returns:
  the parameter default value

const std::string& getGlobalParameterName | ( | int | index | ) | const

Get the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

NonbondedMethod getNonbondedMethod | ( |  | ) | const

Get the method used for handling long range nonbonded interactions.

int getNumAcceptors | ( |  | ) | const`[inline]`

Get the number of acceptors for which force field parameters have been defined.

int getNumDonors | ( |  | ) | const`[inline]`

Get the number of donors for which force field parameters have been defined.

int getNumExclusions | ( |  | ) | const`[inline]`

Get the number of donor-acceptor pairs whose interactions should be excluded.

int getNumFunctions | ( |  | ) | const`[inline]`

Get the number of tabulated functions that have been defined.

Deprecated:
  This method exists only for backward compatibility. Use getNumTabulatedFunctions() instead.

int getNumGlobalParameters | ( |  | ) | const`[inline]`

Get the number of global parameters that the interaction depends on.

int getNumPerAcceptorParameters | ( |  | ) | const`[inline]`

Get the number of per-acceptor parameters that the interaction depends on.

int getNumPerDonorParameters | ( |  | ) | const`[inline]`

Get the number of per-donor parameters that the interaction depends on.

int getNumTabulatedFunctions | ( |  | ) | const`[inline]`

Get the number of tabulated functions that have been defined.

const std::string& getPerAcceptorParameterName | ( | int | index | ) | const

Get the name of a per-acceptor parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

const std::string& getPerDonorParameterName | ( | int | index | ) | const

Get the name of a per-donor parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

TabulatedFunction& getTabulatedFunction | ( | int | index | ) |

Get a reference to a tabulated function that may appear in the energy expression.

Parameters:

  | index | the index of the function to get

Returns:
  the TabulatedFunction object defining the function

const TabulatedFunction& getTabulatedFunction | ( | int | index | ) | const

Get a const reference to a tabulated function that may appear in the energy expression.

Parameters:

  | index | the index of the function to get

Returns:
  the TabulatedFunction object defining the function

const std::string& getTabulatedFunctionName | ( | int | index | ) | const

Get the name of a tabulated function that may appear in the energy expression.

Parameters:

  | index | the index of the function to get

Returns:
  the name of the function as it appears in expressions

void setAcceptorParameters | ( | int | index,
|  | int | a1,
|  | int | a2,
|  | int | a3,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Set the properties of an acceptor group.

Parameters:

  | index | the index of the acceptor group to set
  | a1 | the index of the first particle for this acceptor group
  | a2 | the index of the second particle for this acceptor group. If the group only includes one particle, this must be -1.
  | a3 | the index of the third particle for this acceptor group. If the group includes less than three particles, this must be -1.
  | parameters | the list of per-acceptor parameter values for the acceptor

void setCutoffDistance | ( | double | distance | ) |

Set the cutoff distance (in nm) being used.

All interactions for which the distance between d1 and a1 is greater than the cutoff will be ignored. If the NonbondedMethod in use is NoCutoff, this value will have no effect.

Parameters:

  | distance | the cutoff distance, measured in nm

void setDonorParameters | ( | int | index,
|  | int | d1,
|  | int | d2,
|  | int | d3,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Set the properties of a donor group.

Parameters:

  | index | the index of the donor group to set
  | d1 | the index of the first particle for this donor group
  | d2 | the index of the second particle for this donor group. If the group only includes one particle, this must be -1.
  | d3 | the index of the third particle for this donor group. If the group includes less than three particles, this must be -1.
  | parameters | the list of per-donor parameter values for the donor

void setEnergyFunction | ( | const std::string & | energy | ) |

Set the algebraic expression that gives the interaction energy between a donor and an acceptor.

void setExclusionParticles | ( | int | index,
|  | int | donor,
|  | int | acceptor |
| ) |  |  |

Get the donor and acceptor in a pair whose interaction should be excluded.

Parameters:

  | index | the index of the exclusion for which to get donor and acceptor indices
  | particle1 | the index of the donor
  | particle2 | the index of the acceptor

void setFunctionParameters | ( | int | index,
|  | const std::string & | name,
|  | const std::vector< double > & | values,
|  | double | min,
|  | double | max |
| ) |  |  |

Set the parameters for a tabulated function that may appear in the energy expression.

Deprecated:
  This method exists only for backward compatibility. Use setTabulatedFunctionParameters() instead. If the specified function is not a Continuous1DFunction, this throws an exception.

void setGlobalParameterDefaultValue | ( | int | index,
|  | double | defaultValue |
| ) |  |  |

Set the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the default value
  | name | the default value of the parameter

void setGlobalParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void setNonbondedMethod | ( | NonbondedMethod | method | ) |

Set the method used for handling long range nonbonded interactions.

void setPerAcceptorParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a per-acceptor parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void setPerDonorParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a per-donor parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void updateParametersInContext | ( | Context & | context | ) |

Update the per-donor and per-acceptor parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setDonorParameters() and setAcceptorParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-donor and per-acceptor parameters. All other aspects of the Force (the energy function, nonbonded method, cutoff distance, etc.) are unaffected and can only be changed by reinitializing the Context. The set of particles involved in a donor or acceptor cannot be changed, nor can new donors or acceptors be added.

The documentation for this class was generated from the following file:

- CustomHbondForce.h